//
//  CertificateAuthorityThread.java
//
//  Accepts connection requests and processes them
//

package hotTip;

// socket
import java.net.*;
import java.io.*;
import javax.net.ssl.*;

// Swing
import javax.swing.JTextArea;

//  Crypto
import java.security.*;
import java.security.cert.*;
import java.security.spec.*;
import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

//IAIK Classes required
import iaik.x509.*;
import iaik.asn1.structures.AlgorithmID;

// misc
import java.math.BigInteger;

public class CertificateAuthorityThread extends Thread {

    private CertificateAuthority _ca;
    
    // private SSLSocket _socket = null;
    private ServerSocket _serverSocket = null;
    private int _portNum;
    private String _hostName;
    
    private JTextArea _outputArea;

    InputStream is = null;
    OutputStream os = null;
    
    BufferedReader in = null;
    PrintWriter out = null;

    public CertificateAuthorityThread(CertificateAuthority ca) {
	
	super("CertificateAuthorityThread");
	_ca = ca;
	_portNum = ca.getPortNumber();
	_outputArea = ca.getOutputArea();
	_serverSocket = null;

	try {
	    
	    InetAddress serverAddr=InetAddress.getByName(null);
	    _hostName = serverAddr.getHostName();

	} catch(UnknownHostException e) {
	    _hostName = "0.0.0.0";
	}
    }

    /***
     * 
     * Your methods for setting up SSL
     * 
     */
    
    //  Accept connections and service them one at a time
    public void run() {
	
	try {
	    
	    _serverSocket = new ServerSocket(_portNum);
	    
	    _outputArea.append("CA waiting on " +_hostName + " port " + _portNum);	     
	    
	    while (true) {
		
		// will need to be an SSL socket...
		Socket socket = _serverSocket.accept();
		
		//
		//  Got the connection, now do what is required


		//  First complete the handshake
		

		// set up input/output streams
		is = socket.getInputStream();
		os = socket.getOutputStream();
		
		in = new BufferedReader(new InputStreamReader(is));
		out = new PrintWriter(os,true);
		
		//  Get username and password	       
		String line = null;				

		while ( ! ( line = in.readLine() ).equals("END") ) {			    
		    
		    System.out.println("CA received from BrokerClient: " + line);
		}
		
		//  verify the username and password hash		
		
		
		//
		out.println("OK");
		
		//  issue a certificate signed with the CA's private key


		// sent that signed cert back to the client

	    } 
	}
	
	catch (Exception e) {
	    System.out.println("CA thread error: " + e.getMessage());
	    e.printStackTrace(); }	
    }
}
