//
//  Room B Extension
//
//  Written : Priyank Patel <pkpatel@cs.stanford.edu>
//  Simple extension used to determine whether the user has access to the 
//  room B.
//

package hotTip;

import java.util.*;

import iaik.x509.*;
import iaik.asn1.*;
import iaik.x509.extensions.*;

public class ClientTypeExtension extends V3Extension
{

  //Used to identify this extension in an X509Certificate Object
  public static final ObjectID oid = new ObjectID("1.2.3.4.5.2",
						  "ClientType",
						  "ClientType");

  BOOLEAN value;
  
  ClientTypeExtension(BOOLEAN clientType)
  {
    value = clientType;
  }
  
  public ObjectID getObjectID()
  {
    return oid;
  }

  public void init(ASN1Object clientType)
  {
    value = (BOOLEAN)clientType;
  }

  public int hashCode()
  {
    return oid.hashCode();
  }

  //Use this function to get the value
  public ASN1Object toASN1Object()
  {
    return value;
  }
}
